

(define WIDTH 500)
(define HEIGHT 500)

(define frame (make-object wx:frame% () "Array" -1 -1 WIDTH HEIGHT))
(define panel (make-object wx:panel% frame 0 0 WIDTH HEIGHT))

(define make-array
  (lambda (h-count v-count item-maker)
    (let ([width (/ WIDTH h-count)]
	  [height (/ HEIGHT v-count)])
      (let v-loop ([v-count v-count][j 0])
	(if (zero? v-count)
	    ()
	    (cons (let h-loop ([h-count h-count][i 0])
		    (if (zero? h-count)
			()
			(cons (item-maker (* i width) (* j height)
					  width height 
					  i j)
			      (h-loop (sub1 h-count)
				      (add1 i)))))
		  (v-loop (sub1 v-count)
			  (add1 j))))))))

(define array%
  (make-class ()
	      (class
	       (h 4)
	       (w 4))
	      (public
	       objects)
	      (lambda (panel)
		(set! objects
		      (make-array 
		       h w
		       (lambda (x y w h i j)
			 (make-object wx:text% 
				      panel 
				      ()
				      "" 
				      (string-append (number->string i)
						     ", "
						     (number->string j))
				      x y w h)))))
	      (lambda (name)
		(lambda args
		  (map (lambda (row)
			 (map
			  (lambda (obj)
			    (apply (uq-ivar obj name) args))
			  row))
		       objects)))))

(define array (make-object array% panel))

(send frame show #t)
