
(define mb-test
  (lambda ()
    (let ((menu (make-object wx:menu%)))
      (send menu append 1 "Hi")
      (make-object wx:menu-bar% (list menu) (list "x")))))

(define frame1%
  (make-class wx:frame%
	      (private mb)
	      (lambda args
		(apply-super-init args)
		(set! mb (make-object wx:menu-bar%))
		((ivar set-menu-bar) mb)
		(let ((menu (make-object wx:menu%)))
		  (send menu append 1 "Hi")
		  (send mb append menu "X")))))

(define frame%
  (make-class wx:frame%
	      (private mb)
	      (private (menu-proc
			(lambda (menu command)
			  #f)))
	      (lambda args
		(apply-super-init args)
		(let ((menu (make-object wx:menu%))
		      (menu2 (make-object wx:menu%)))
		  (send menu append 1 "Hi")
		  (set! mb (make-object wx:menu-bar%
					(list menu)
					(list "X")))
		  (send mb append menu2 "y")
		  ((ivar set-menu-bar) mb)))))

(define frame2%
  (make-class wx:frame%
	      (private canvas)
	      (lambda args
		(apply-super-init args)
		(send (make-object wx:media-canvas% this)
		      set-media
		      (make-object wx:media-edit%))
		(send this show #t)
		(send this show #f))))

(define gc collect-garbage)

(show-collection #t)

(define loop
  (lambda (f n)
    (let loop ((n n))
      (if (zero? n)
	  #t
	  (begin
	    (f)
	    (loop (- n 1)))))))

(define gctest
  (lambda ()
    (loop (lambda () (make-object frame% () "x") (gc)) 10)))

(define gctest2
  (lambda ()
    (loop (lambda ()
	    (let ([f (make-object mred:simple-frame%)])
	      (send f show #f)))
	  10)))

(define gctest2.2
  (lambda ()
    (loop (lambda ()
	    (let ([f (make-object mred:frame% "gctest.ss")])
	      (send f show #f)))
	  10)))

(define gctest2.1
  (lambda ()
    (loop (lambda ()
	    (let ([f (make-object mred:frame%)])
	      (send f show #f)))
	  10)))

(define gctest3
  (lambda ()
    (loop (lambda () (make-object frame2% () "x") (gc)) 10)))

