
(define-macro mred:define-autoload 
  (lambda (name file)
    `(define ,name
       (let ([auto (make-autoload (quote ,name) ,file)]
	     [used? #f])
	 (lambda args
	   (if used?
	       (error "Undefined after autoloading: " (quote ,name))
	       (dynamic-wind
		(lambda ()
		  (set! used? #t))
		(lambda ()
		  (apply auto args))
		(lambda ()
		  (set! used? #f)))))))))

