
; Map "(constant x)" to "(constant-symbol 'x)" if constants are
;  disabled
(define-macro constant 
  (lambda (symbol)
    `(if (and (defined? 'mzlib:constant-lib?) mzlib:constant-lib?)
	 (constant-name (quote ,symbol)))))
(constant constant)

(define-macro mzlib-constant 
  (lambda (symbol)
    `(if (and (defined? 'mzlib:constant-lib?) mzlib:constant-lib?
	      (or (not (defined? 'mzlib:open-functors?)) mzlib:open-functors?))
	 (constant-name (quote ,symbol)))))
(constant mzlib-constant)


; Open functor unless disabled
(define-macro open-mzlib-functor
  (lambda (f . pathl)
    `(if (or (not (defined? 'mzlib:open-functors?)) mzlib:open-functors?)
	 (invoke-open-functor (sigfunctor->functor ,f)
			      ,(if (null? pathl)
				   '()
				   (car pathl))))))
(constant open-mzlib-functor)

