(zodiac:require (build-relative-path "Source" "Macros" "prelim"))

(zodiac:require (build-relative-path "Source" "Macros" "expander"))

(if zodiac:print-on-startup
  (printf "Expander loaded~n"))

(begin
  (define expand zodiac:expand)
  (define syntax-dispatch zodiac:syntax-dispatch)
  (define generate-temporaries zodiac:generate-temporaries)
  (define identifier? zodiac:identifier?)
  (define syntax-error zodiac:syntax-error)
  (define syntax-object->datum zodiac:syntax-object->datum)
  (define bound-identifier=? zodiac:bound-identifier=?)
  (define free-identifier=? zodiac:free-identifier=?)
  (define install-global-transformer zodiac:install-global-transformer)
  (define datum->syntax-object zodiac:datum->syntax-object)
  (define syntax-error zodiac:syntax-error)
  (define get-macro-env zodiac:get-macro-env)
  (define put-macro-env zodiac:put-macro-env))

(define zodiac:sc-expand zodiac:expand)

(zodiac:require (build-relative-path "Source" "Macros" "dt"))

(if (eq? zodiac:macro-lib-from 'source)
  (with-input-from-file (zodiac:resolve-filename
			  (build-relative-path "Source" "Macros" "macros-src"))
    (lambda ()
      (let loop ((e (read)))
	(if (eof-object? e) 'loaded
          (begin (zodiac:sc-expand e) (loop (read)))))))
  (zodiac:require (build-relative-path "Source" "Macros" "macros")))

(if (eq? zodiac:macro-lib-from 'source)
  (begin
    (zodiac:dt-load (zodiac:resolve-filename
		      (build-relative-path "Source" "Macros" "dt-base"))))
  (begin
    (zodiac:require (build-relative-path "Source" "Macros" "x-base"))))

(if zodiac:print-on-startup
  (printf "Macros installed~n"))
