#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <unistd.h>

char  * fifoName = NULL ;

void
exitHandler ( void )
{
  if ( NULL != fifoName )
    unlink ( fifoName ) ;
}

int
main ( int  argCount , char  * argList [ ] )
{
  FILE  * fifoFile ;
  char  c ;
  int   returnValue ;

  if ( 2 != argCount )
  {
    fprintf ( stderr , "Usage: readFifo filename\n" ) ;
    exit ( 1 ) ;
  }

  atexit ( exitHandler ) ;

  fifoName = argList [ 1 ] ;
  mkfifo ( fifoName , S_IRUSR | S_IWUSR | S_IWOTH ) ;
  fifoFile = fopen ( fifoName , "r" ) ;

  do
  {
    returnValue = fscanf ( fifoFile , "%c" , & c ) ;
    if ( EOF != returnValue )
      fprintf ( stdout , "%c" , c ) ;
  }
  while ( EOF != returnValue ) ;
  
  exit ( 0 ) ;
}
