;Dan Grossman

;Sample class derived from std-pedantic-scheme%

(define advance-check%
  (make-class
   std-check%
   (inherit generate-keyword-checks-list generate-lex-checks-list)
   (public
    [name "advance-check"])
   (lambda ()
     (super-init)
     (generate-keyword-checks-list
      (append
       (list 
	(make-keyword-check 
	 (list 'define) 
	 (list (ivar std-check% this def-symbol)))
	(make-keyword-check 
	 (ivar std-check% this one-arg-words) 
	 (list (ivar std-check% this one-arg)))
	(make-keyword-check 
	 (ivar std-check% this two-arg-words)
	 (list (ivar std-check% this two-args)))
	(make-keyword-check 
	 (ivar std-check% this two-or-three-arg-words) 
	 (list (ivar std-check% this two-or-three-args)))
	(make-keyword-check
	 (ivar std-check% this min-one-arg-words)
	 (list (ivar std-check% this min-one-arg)))
	(make-keyword-check
	 (ivar std-check% this min-two-arg-words)
	 (list (ivar std-check% this min-two-args)))
	(make-keyword-check
	 (list 'cond)
	 (list (ivar std-check% this cond-check)))
	(make-keyword-check 
	 (ivar std-check% this let-args-words)
	 (list (ivar std-check% this bindings-in-parens)
	       (ivar std-check% this min-two-args))))
       (ivar std-check% this keyword-checks-list)))
      (generate-lex-checks-list
       (append
	(list (ivar std-check% this syntax-first))
	(ivar std-check% this lex-checks-list))))))

(define beginner-check%
  (make-class
   advance-check%
   (inherit generate-keyword-checks-list)
   (public
    [name "beginner-check"])
   (lambda ()
     (super-init)
     (generate-keyword-checks-list
      (append
       (list
	(make-keyword-check 
	 (ivar advance-check% this three-arg-words-beginner)
	 (list (ivar advance-check% this three-args)))
	(make-keyword-check 
	 (ivar advance-check% this let-args-words)
	 (list (ivar advance-check% this let-beginner)))
	(make-keyword-check 
	 (list 'lambda) 
	 (list (ivar advance-check% this lambda-beginner)
	       (ivar advance-check% this two-args))))
       (ivar advance-check% this keyword-checks-list))))))


