(define change
    (lambda (edit)
      (let ([lines (send edit last-line)]
            [italic 
	     (send (make-object wx:style-delta%)
		   set-delta wx:const-change-style wx:const-italic)]
            [slant 
	     (send (make-object wx:style-delta%)
		   set-delta wx:const-change-style wx:const-slant)]
            [bold 
	     (send (make-object wx:style-delta%)
		   set-delta wx:const-change-weight wx:const-bold)]
            [bold-italic 
	     (send
	      (send (make-object wx:style-delta%)
		    set-delta wx:const-change-weight wx:const-bold)
	      set-delta wx:const-change-style wx:const-italic)]
            [bold-slant
	     (send
	      (send (make-object wx:style-delta%)
		    set-delta wx:const-change-weight wx:const-bold)
	      set-delta wx:const-change-style wx:const-slant)]
	    [insert
	     (lambda (text style)
	       (let ([start (send edit get-start-position)])
		 (send edit insert text)
		 (let ([end (send edit get-start-position)])
		   (send edit insert " ")
		   (send edit change-style style start end))))])
	(dynamic-wind
	 (lambda ()
	   (send edit begin-edit-sequence))
	 (lambda ()
	   (let loop ([l 0])
	     (when (<= l lines)
		   (let* ([start (send edit line-start-position l)]
			  [end (send edit line-end-position l)]
			  [text (send edit get-text start end)])
		     (send edit set-position end)
		     (send edit insert " ")
		     (insert text italic)
		     (insert text slant)
		     (insert text bold)
		     (insert text bold-italic)
		     (insert text bold-slant))
		   (loop (add1 l)))))
	 (lambda ()
	   (send edit end-edit-sequence))))))
