(define f%
  (let-enumerate ([ADD-APPLE
		   ADD-BANANA
		   ADD-COCONUT
		   DELETE-APPLE
		   DELETE-BANANA
		   DELETE-COCONUT
		   COCONUT-ID
		   DELETE-ONCE])
    (make-class mred:frame%
      (inherit next-menu-id make-menu)
      (rename
       [super-make-menu-bar make-menu-bar]
       [super-on-menu-command on-menu-command])
      (private
	offset
	menu-bar
	apple-menu
	banana-menu
	coconut-menu)
      (public
	[make-menu-bar
	 (lambda ()
	   (let ([mb (super-make-menu-bar)]
		 [menu (make-menu)])
	     (set! offset (next-menu-id))
	     (set! menu-bar mb)
	     
	     (send menu append (+ offset ADD-APPLE) "Add Apple")
	     (send menu append (+ offset ADD-BANANA) "Add Banana")
	     (send menu append (+ offset ADD-COCONUT) "Add Coconut")
	     (send menu append-separator)
	     (send menu append (+ offset DELETE-COCONUT)
		   "Delete Coconut")
	     (send menu append-separator)
	     (send menu append-check-set
		   (list "Astros" "Braves" "Cardinals")
		   (lambda (which)
		     (wx:message-box (format "~s Checked" which))))
	     (send menu append-separator)
	     (send menu append-check-set
		   `(("Aeros" . Houston) 
		     ("Bruins" . Boston)
		     ("Capitals" . Washington))
		   (lambda (which)
		     (wx:message-box (format "~s Checked" which))))
	     
	     (set! apple-menu (make-menu))
	     (set! banana-menu (make-menu))
	     (set! coconut-menu (make-menu))
	     
	     (send apple-menu append (+ offset DELETE-ONCE)
		   "Delete Once")
	     (send apple-menu append (+ offset DELETE-APPLE)
		   "Delete Apple")
	     (send banana-menu append (+ offset DELETE-BANANA)
		   "Delete Banana")
	     (send coconut-menu append (+ offset DELETE-COCONUT)
		   "Delete Coconut")
	     
	     (send mb append menu "Tester")
	     mb))]
	[on-menu-command
	 (lambda (orig-op)
	   (let ([op (- orig-op offset)])
	     (cond
	      [(= op ADD-APPLE)
	       (send menu-bar append apple-menu "Apple")]
	      [(= op ADD-BANANA)
	       (send menu-bar append banana-menu "Banana")]
	      [(= op ADD-COCONUT)
	       (send apple-menu append (+ offset COCONUT-ID)
		     "Coconut" coconut-menu)]
	      [(= op DELETE-ONCE)
	       (send apple-menu delete (+ offset DELETE-ONCE))]
	      [(= op DELETE-APPLE)
	       (send menu-bar delete apple-menu)]
	      [(= op DELETE-BANANA)
	       (send menu-bar delete banana-menu)]
	      [(= op DELETE-COCONUT)
	       (send apple-menu delete (+ offset COCONUT-ID))]
	      [else
	       (super-on-menu-command orig-op)])))]))))

(make-object f%)

		   
	    