
(define menu-callback 
  (lambda (menu command)
    (let* ((selected (send command get-selection))
	   (name (send menu get-label selected)))
      (display "Menu selection: ")
      (display name)
      (newline)
      (send f show #f))))
      

(define new-menu (make-object wx:menu% "Extra" menu-callback))
(define other-menu (make-object wx:menu% "Again" menu-callback))

(send other-menu append 100 "Hello Again" "")
(send other-menu append-separator)
(send other-menu append 101 "Other World" "")

(send new-menu append 100 "Hello" "")
(send new-menu append-separator)
(send new-menu append 101 "World" "")

(display 'done)

(define f (make-object wx:frame% '() "x" 0 0 100 100))
(define c (make-object
	   (make-class wx:canvas%
	     (public
	      [x #f]
	      [on-event
	       (lambda (evt)
		 (cond
		  [(send evt left-down?)
		   (send this popup-menu new-menu 50 50)]
		  [(send evt right-down?)
		   (send this popup-menu other-menu 50 50)]))]))
	   f 0 0 100 100))

(send f show #t)
