
(define f (make-object mred:frame%))
(define e (ivar f edit))

(send f show  #t)

(send e insert  "This is in the SPECIAL style.")
(send e insert  #\newline)
(send e insert  "This is in the OTHER style.")
(send e insert  #\newline)
(send e insert  "This is in the SPECIAL+OTHER style.")
(define sl (send e get-style-list))

(define s (send sl find-or-create-style  
		() 
		(make-object wx:style-delta%
			     wx:const-change-bold)))
(define special (send sl new-named-style  "Special" s))
(define s (send sl find-or-create-style  
		() 
		(make-object wx:style-delta%
			     wx:const-change-underline 1)))
(define other (send sl new-named-style  "Other" s))

(define plus (send sl find-or-create-join-style  special other))

(send e change-style  special 15 23)
(send e change-style  other 45 50)
(send e change-style  plus 73 86)

; Run this function to change the "Special" style to italicizing
(define change-to-italic
  (lambda ()
    (send special set-delta  
	  (make-object wx:style-delta% wx:const-change-italic))))

; Run this function to change the "Other" style to toggle-italicizing
(define change-to-toggle-italic
  (lambda ()
    (send other set-delta  
	  (make-object wx:style-delta% 
		       wx:const-change-toggle-style
		       wx:const-italic))))
