(define zodiac:transmit-to-device
  (lambda messages
    (let ((hd (car messages))
	  (tl (cdr messages)))
      (printf "Message = ~s~n" hd)
      (let loop
	  ((msgs tl))
	(cond
	 ((null? msgs) (void))
	 ((null? (cdr msgs))
	  (for-each (lambda (msg)
		      (pretty-print msg))
		    (car msgs)))
	 (else (pretty-print (car msgs))
	       (loop (cdr msgs)))))
      (newline))))

(zodiac:top-level-contn
  (lambda (value)
    (error 'zodiac:top-level-contn "value = ~s" value)))

(if zodiac:print-on-startup
  (printf "Terminal configured~n"))
