(define zodiac:values values)
(define zodiac:call-with-values call-with-values)

(define-structure (syntax-object expression wrap))

(define-structure (zodiac:location line column offset file))

(define-structure (zodiac:token text type start finish))

(define-structure (zodiac:open-paren text location))
(define-structure (zodiac:close-paren text location))
(define-structure (zodiac:phantom-paren kind location))

(define-structure (zodiac:period location))

(define-structure (zodiac:eof location))

(define-structure (zodiac:string text start finish))
(define-structure (zodiac:boolean text start finish))
(define-structure (zodiac:char text start finish))
(define-structure (zodiac:symbol text start finish))
(define-structure (zodiac:number text start finish))

(define-structure (zodiac:list contents length open close))
(define-structure (zodiac:improper-list contents length open close))
(define-structure (zodiac:vector contents length open close))

(define-structure (zodiac:back-entry location boxes))

;(define-structure (zodiac:delay-form expr open close back))
;(define-structure (zodiac:if-form test then else open close back))
;(define-structure (zodiac:lambda-form args body level open close back))
;(define-structure (zodiac:set!-form var val open close back))
;(define-structure (zodiac:quote-form expr open close back))
;(define-structure (zodiac:begin-form first rest open close back))
;(define-structure (zodiac:let-form vars vals body level open close back))
;(define-structure (zodiac:letrec-form vars vals body level open close back))
;(define-structure (zodiac:define-form name value open close back))

;(define-structure (zodiac:app fun args open close back))

(define-structure (zodiac:lexical-varref var binding back))
(define-structure (zodiac:top-level-varref var back))
(define-structure (zodiac:unbound-varref var back))

(define-structure (zodiac:unchanged body open close))

(define-structure (zodiac:bound var box))
(define-structure (zodiac:binding level offset var))
