(define zodiac:box-default-value 0)

(define zodiac:back-boxes '())

(define zodiac:find-boxes-for
  (let ((null? null?) (car car) (cdr cdr))
    (lambda (location)
      (let loop
	((back-boxes zodiac:back-boxes))
	(if (null? back-boxes)
	  #f
	  (let ((first (car back-boxes)))
	    (if (zodiac:same-location? location
		  (zodiac:back-entry-location first))
	      first
	      (loop (cdr back-boxes)))))))))

(define zodiac:add-to-box-list
  (let ((cons cons) (list list))
    (lambda (location box)
      (let ((entry (zodiac:find-boxes-for location)))
	(if entry
	  (set-zodiac:back-entry-boxes!
	    entry
	    (cons box (zodiac:back-entry-boxes entry)))
	  (set! zodiac:back-boxes
	    (cons (make-zodiac:back-entry location (list box))
	      zodiac:back-boxes)))))))

(define (zodiac:make-back-box location)
  (let ((new-box (box zodiac:box-default-value)))
    (zodiac:add-to-box-list (zodiac:determine-start-location location) new-box)
    new-box))
